;wait 40ms

LCD_init:
         mov   LCD_data,#38H  ;Function set: 2 Line, 8-bit, 5x7 dots
         clr   LCD_rs         ;Selected command register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         lcall LCD_busy       ;Wait for LCD to process the command
		 mov   LCD_data,#38H  ;Function set: 2 Line, 8-bit, 5x7 dots
         clr   LCD_rs         ;Selected command register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         acall LCD_busy       ;Wait for LCD to process the command
		 mov   LCD_data,#38H  ;Function set: 2 Line, 8-bit, 5x7 dots
         clr   LCD_rs         ;Selected command register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         call LCD_busy       ;Wait for LCD to process the command
         mov   LCD_data,#0CH  ;Display on, Curson blinking command
         clr   LCD_rs         ;Selected instruction register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         acall LCD_busy       ;Wait for LCD to process the command
         mov   LCD_data,#01H  ;Clear LCD
         clr   LCD_rs         ;Selected command register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         acall LCD_busy       ;Wait for LCD to process the command
         mov   LCD_data,#06H  ;Entry mode, auto increment with no shift
         clr   LCD_rs         ;Selected command register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         acall LCD_busy       ;Wait for LCD to process the command
         ret                  ;Return from routine

;Ports used are same as the previous example

LCD_busy:
         setb   LCD_D7        ;Make D7th bit of LCD data port as i/p
         setb   LCD_en        ;Make port pin as o/p
         clr    LCD_rs        ;Select command register
         setb   LCD_rw        ;we are reading
check:
         clr    LCD_en        ;Enable H->L
         setb   LCD_en
         jb     LCD_D7,check  ;read busy flag again and again till it becomes 0
         ret                  ;Return from busy routine


;Ports used are same as the previous example
;Routine to send command to LCD

LCD_command:
         mov   LCD_data,A     ;Move the command to LCD port
         clr   LCD_rs         ;Selected command register
         clr   LCD_rw         ;We are writing in instruction register
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         acall LCD_busy       ;Wait for LCD to process the command
         ret                  ;Return from busy routine

; Usage of the above routine
; A will carry the command for LCD
; e.g. we want to send clear LCD command
;
; mov   a,#01H         ;01H is command for clearing LCD
; acall LCD_command    ;Send the command

;Ports used are same as the previous example
;Routine to send data (single character) to LCD

LCD_senddata:
         mov   LCD_data,A     ;Move the command to LCD port
         setb  LCD_rs         ;Selected data register
         clr   LCD_rw         ;We are writing
         setb  LCD_en         ;Enable H->L
         clr   LCD_en
         acall LCD_busy       ;Wait for LCD to process the data
         ret                  ;Return from busy routine

; Usage of the above routine
; A will carry the character to display on LCD
; e.g. we want to print A on LCD
;
; mov   a,#'A'         ;Ascii value of 'A' will be loaded in accumulator
; acall LCD_senddata   ;Send data

;Sending string to LCD Example

LCD_sendstring:
         clr   a                 ;clear Accumulator for any previous data
         movc  a,@a+dptr         ;load the first character in accumulator
         jz    exit              ;go to exit if zero
         call lcd_senddata      ;send first char
         inc   dptr              ;increment data pointer
         sjmp  LCD_sendstring    ;jump back to send the next character
exit:
         ret                     ;End of routine

my_string:
DB "INIT LCD",00H

my_string3:
DB "INIT SYSTEM",00H

my_string4:
DB "ATR:",00H

my_string5:
DB "Status=9000",00H

my_string6:
DB "Status=6D00",00H

my_string8:
DB "COUNT=",00H

my_string9:
DB "Status=6E00",00H

my_string11:
DB "INSERT APDU",00H

my_string12:
DB "CARD REMOVED",00H

my_string13:
DB "INSERT CARD",00H

my_string14:
DB "ERASE ALL",00H

my_string15:
DB "WRITE ALL",00H

my_string16:
DB "CPU",00H

my_string17:
DB "X=?",00H		

my_string18:
DB "Y=?",00H

my_string19:
DB "RUN.TESTING",00H


my_string20:
DB "COUNT:",00H

my_string21:
DB "ENDURANCE",00H

my_string22:
DB "ERROR!!(*_*)",00H

my_string23:
DB "SUCCESS!!(^_^)",00H

my_string24:			 ;erase all checksum
DB "215C9000",00H

my_string25:			;write all checksum
DB "6E379000",00H

my_string26:			  ;even odd checksum
DB "666F9000",00H

my_string27:
DB "CHECKSUM",00H

my_string28:
DB "WRITEEVEN",00H

my_string29:
DB "WRITEODD",00H

my_string30:
DB "ATR ERROR!!",00H

;my_string31:
;DB "MSB=?",00H

;my_string32:
;DB "LSB=?",00H

my_string33:
DB "ENDURANCE BIST",00H

my_string34:
DB "KEYGEN",00H

my_string35:
DB "MATHC0 512bit",00H

;my_string36:
;DB "XX=?",00H

my_string37:
DB "SWITCH CLOCK",00H

;my_string38:
;DB "CPU CLOCK=30MHz",00H

;my_string39:
;DB "YY=?",00H

my_string40:
DB "OTP by CRC",00H

my_string41:
DB "RSA 512bit",00H

my_string42:
DB "Status=6100",00H

my_string43:
DB "TIMER",00H

my_string44:
DB "WATCHDOG",00H

my_string45:
DB "SRAM_BIST",00H

my_string46:
DB "DES-CBC",00H

my_string47:
DB "DESnonCBC",00H

;my_string48:
;DB "REMOVE CARD",00H

my_string49:
DB "SHA",00H

my_string50:
DB "EraseByte",00H

my_string51:
DB "Z=?",00H

my_string52:
DB "Loop1024bit RSA",00H

my_string53:
DB "LongDelay",00H

my_string54:
DB "WriteWholeX",00H
; Usage of the above routine
; DPTR(data pointer) will carry the address
; of string to send to LCD.
; e.g. we want to print "LCD Tutorial" on LCD then
;
; mov   dptr,#my_string   ;my_string is the label where the string is stored
; acall LCD_sendstring    ;Send string
;
; To store a string..
; my_string:
; DB   "LCD Tutorial", 00H
; 00H indicate that string is finished.

