;eeprom test using xternal clock
;use 9600 baud rate=372 clock cycles
;since using crystal 22.1184MHz for microcontroller and 1.8432MHz for card
;it is 12times faster, so the condition is 1mc(22.1184MHz)=1cc(1.8432MHz) for all baudrate
;
;Erase all	00	10	00	00	00	9000 
;Write all	00	12	00	00	00	9000 
;check 8051 instructions	00 02 00 00 00
;==========================9600========================================

put_hi9600:
	clr IO		;1mc start bit 
	mov r0,#08h	;1mc for 8 bit data
	nop
	nop
	nop
	;nop
	acall	etu_9600	;2 mc
put_hi29600:
	rrc a		;1mc rotate bit in acc
	nop	
	mov IO,C	;2mc put out bit	
	acall  etu_9600	;2mc
	djnz r0,put_hi29600	;2mc
	nop
	nop 
	setb	IO	;	 > set parity
	nop
	;setb	IO
	nop
	nop
	nop
	acall	etu_9600	;	)

	setb	IO;	starting of guard time}
		//nop		  
	djnz r2,continueGT96//nop		  
	jmp status96//nop		  

continueGT96:
	clr a
	nop
	acall etu_9600
	nop
	nop
	nop	
	;acall delay_5 ;delay for 5mc
	acall etu_9600;	|
	ret			 ;@371mc
;==========================================================================
;=============================if low parity bit============================
;==========================================================================
put_lo9600:
	clr IO		;1mc start bit 
	mov r0,#08h	;1mc for 8 bit data
	nop
	nop
	nop
	acall	etu_9600	;2 mc
put_lo29600:
	rrc a		;1mc rotate bit in acc	
	nop
	mov IO,C	;2mc put out bit	
	acall  etu_9600	;2mc
	djnz r0,put_lo29600	;2mc 
	nop
	nop
	clr	IO	;	 > set parity
	nop
	;clr IO
	nop
	nop
	nop
	;acall delay_5 ;delay for 5 mc
	acall	etu_9600	;	)
	setb	IO;	}
	
	djnz	r2,continueGT962
	jmp		status96

continueGT962:
	clr a
	nop
	;nop
	;nop
	acall etu_9600
	nop
	nop
	nop
	acall etu_9600;	|
	ret

;============================38k=====================================

put_hi38k:
	clr IO		;start bit 1mc
	mov r0,#8	;1mc
	nop
	nop
	nop
	nop
	acall	etu_38k	;2 mc	
put_hi238k:	
	rrc a
	mov IO,C	;2mc
  	acall  etu_38k	;2mc
	;rlc a		;1mc
	nop
	djnz r0,put_hi238k	;2mc 
	nop
	nop
	setb	IO	;	 > set parity
	setb	IO
	setb	IO
	nop
	nop
	nop
	acall	etu_38k	;	)
	setb	IO;	}  start guardtime
	setb	IO
	nop
	nop	   ;complete
;	nop	   ;1 bit
;	nop	   ;GuardTime
;->	acall etu_38k	;| will be @ 90mc ==less 3mc
	acall	etu38k_2
;2nd GuardTime
	djnz	r2,continueGT 
	jmp		status38	
	setb	IO	; > GUARD TIME + STOP BIT
	clr a
;	nop
;	nop
/**/	
;->	djnz	r2,continueGT
;->	jmp		status38
continueGT:
/**/	
	acall etu_38k;	|
	ret

put_lo38k:
	clr IO		;start bit 1mc
	mov r0,#8	;1mc
	nop
	nop
	nop
	nop
	acall	etu_38k	;2 mc	
put_lo238k:	
	rrc a
	mov IO,C	;2mc
	acall  etu_38k	;2mc
	;rlc a		;1mc
	nop
	djnz r0,put_lo238k	;2mc 
	nop
	nop
	clr	IO	;	 > set parity	
	clr	IO
	clr	IO
	nop
	nop
	nop
	acall	etu_38k	;	)
	setb	IO;	}  start guardtime
	setb	IO
	nop
	nop	;;complete 
;	nop	;;1 bit
;	nop	;;GuardTime
;->	acall etu_38k	;|
	acall	etu38k_2
	djnz	r2,continueGT2
	jmp		status38
	setb	IO	; > GUARD TIME + STOP BIT
	
	clr a
;;	nop
	nop
	
;->	djnz	r2,continueGT2
;->	jmp		status38
continueGT2:

	acall etu_38k;	
	ret

;====================================================================
;============================115k====================================
;BAUD RATE; 115.2K
;consume 31mc 
/*
put_hi115k:
	clr IO		;start bit 1mc
	mov r0,#08h	;1mc
	nop
	nop
	nop
	nop
	acall	etu_115k	;2 mc
put_hi2115k:
	rrc a		;1mc	
	mov IO,C	;2mc
	acall  etu_115k	;2mc	
	nop
	;nop
	djnz r0,put_hi2115k	;2mc
	nop
	nop 
	setb	IO	;	 > set parity
	setb	IO
	nop		  
	nop
	nop
	nop
	acall	etu_115k	;	)
	setb	IO;	}
	setb	IO
	nop
	;;nop
	;;nop
	acall etu_115k	;|
	djnz	r2,continueGT115k
	jmp		status115
continueGT115k:
	setb	IO	; 
;	setb	IO
	clr a
;	nop
	acall etu_115k;	|
	ret

put_lo115k:
	clr IO		;start bit 1mc
	mov r0,#08h	;1mc
	nop
	nop
	nop
	nop
	acall	etu_115k	;2 mc
put_lo2115k:
	rrc a		;1mc	
	mov IO,C	;2mc
	acall  etu_115k	;2mc	
	nop
	;nop
	djnz r0,put_lo2115k	;2mc
	nop
	nop 
	clr	IO	;	 > set parity
	clr	IO
	nop		  
	nop
	nop
	nop
	acall	etu_115k	;	)
	setb	IO;	}
	setb	IO
	nop
	;;nop
	;;nop
	acall etu_115k	;|
	djnz	r2,continueGT115k2
	jmp		status115
continueGT115k2:
	setb	IO	; 
;	setb	IO
	clr a
;	nop
	acall etu_115k;	|
	ret
*/
;====================================================================
;========================9.6k baudrate==============================

etu_9600:	
		mov r1,#182    ;1mc
		;nop
dect:	djnz r1,dect  ;2mc X   = 364
		ret	     ;2mc total=372mc including calling func and IO bit 
;needs 372 clock cycles of 1.8432MHz clock
/*
delay_5:
		nop
		ret				;total=5mc
*/
;========================38k baudrate===============================
etu_38k:	mov r1,#40    ;1mc
			nop	
dect_38k:
			djnz r1,dect_38k ;2mc X = 80
			ret	     ;2mc total=needs 93mc for 22.1184MHz 
;needs 93 clock cycles of 1.8432MHz clock

etu38k_2:	mov	r1,#15	;previous value=21
			nop
dect_38k_2:
			djnz r1,dect_38k_2
			ret
;========================115.2k baud rate=============================
/*
etu_115k:	mov r1,#10    ;1mc	
dect_115k:
			djnz r1,dect_115k ;2mc X = 20
			ret	     ;2mc total=needs 31mc for 22.1184MHz 
;needs 31 clock cycles of 1.8432MHz clock
*/
;==========================PTS=======================================
;protocol type selection,shall be send directly after ATR if want to change the 
;baud rate instead of 9600.otherwise it will stick to 9600.
;it TA(2) is present->specific mode
;if TA(2) isn't present -> negotiable mode
	
PTS:mov r2,#5
	mov a,#0FFh			;send initial PTS
	acall put_lo9600   
	mov a,#10h			;send protocal T=0
	acall put_hi9600
	mov a,#13h		   ;send baudrate = 38k	 ,#18=115.2k
	acall put_hi9600	
	mov a,#0FCh		   ;send PCK  ,#0F7h=115.2k
	acall put_lo9600	
	nop
	ret
delayPTS:
		mov r6,#8                                  	  ;5
loop:	
		mov r7,#50
decr:
		djnz r7,decr
		djnz r6,loop			
		ret

;==================================XX data===================================
XX_data:	
		mov		a,#0C0H
		lcall	LCD_command
		mov   	dptr,#my_string17     ;write byte XX    
		lcall   LCD_sendstring
		mov		15h,#0C2H		  	  ;r5 bnk 2
		call	get_key2
swap_noXX:		
		swap	a				;swap lower nib with high nib
		mov		63H,a
		mov		15h,#0C3H
		call	get_key2   		;get 2nd input for X
		
loadXX:	
		mov		r0,#63H
    	xchd	a,@r0			;xchange low nibble of each operand
		xch		a,@r0
		mov		63h,a			;save XX number again to 63h RAm address
		ret	
		
;================================================================================
;this routine check parity for XX data after user has input the number
check_parityXX:
		mov		r2,#8
		mov		43h,#00h		 ;the RAM address to calculate parity even@odd
check_parityXX2:
		rrc		a
		jc		increment_1_XX
incrXX:
		djnz	r2,check_parityXX2
		mov		r0,#43h
		cjne	@r0,#00h,XXtwo
		clr		23h				;as bit address,put '0' at parity bit place
		ret
XXtwo:	
		cjne	@r0,#02h,XXfour
		clr		23h
		ret		
XXfour:
		cjne	@r0,#04h,XXsix
		clr		23h		
		ret
XXsix:	
		cjne	@r0,#06h,XXeight
		clr		23h		
		ret
XXeight:
		cjne	@r0,#08h,XXout
		clr		23h		 
		ret
XXout:	
		setb	23h		;if not even, put '1' in parity bit place
		ret
				
increment_1_XX:
		inc		43h
		jmp		incrXX		
		;ret
;==================================YY data===================================
YY_data:	
		mov		a,#0C5H
		lcall	LCD_command
		mov   	dptr,#my_string18     ;write byte XX    
		lcall   LCD_sendstring
		mov		15h,#0C7H		  	  ;r5 bnk 2
		call	get_key2
swap_noYY:		
		swap	a				;swap lower nib with high nib
		mov		62H,a
		mov		15h,#0C8H
		call	get_key2   		;get 2nd input for X
		
loadYY:	
		mov		r0,#62H
    	xchd	a,@r0			;xchange low nibble of each operand
		xch		a,@r0
		mov		62h,a			;save XX number again to 63h RAm address
		ret	
		
;================================================================================
;this routine check parity for XX data after user has input the number
check_parityYY:
		mov		r2,#8
		mov		43h,#00h		 ;the RAM address to calculate parity even@odd
check_parityYY2:
		rrc		a
		jc		increment_1_YY
incrYY:
		djnz	r2,check_parityYY2
		mov		r0,#43h
		cjne	@r0,#00h,YYtwo
		clr		24h				;as bit address,put '0' at parity bit place
		ret
YYtwo:	
		cjne	@r0,#02h,YYfour
		clr		24h
		ret		
YYfour:
		cjne	@r0,#04h,YYsix
		clr		24h		
		ret
YYsix:	
		cjne	@r0,#06h,YYeight
		clr		24h		
		ret
YYeight:
		cjne	@r0,#08h,YYout
		clr		24h		 
		ret
YYout:	
		setb	24h		;if not even, put '1' in parity bit place
		ret
				
increment_1_YY:
		inc		43h
		jmp		incrYY		
		;ret
;=========================================================================

ZZ_data:	
		mov		a,#0CAH
		lcall	LCD_command
		mov   	dptr,#my_string51     ;write byte Z    
		lcall   LCD_sendstring
		mov		15h,#0CCH		  	  ;r5 bnk 2
		call	get_key2
swap_noZZ:		
		swap	a				;swap lower nib with high nib
		mov		61H,a
		mov		15h,#0CDH
		call	get_key2   		;get 2nd input for Z
		
loadZZ:	
		mov		r0,#61H
    	xchd	a,@r0			;xchange low nibble of each operand
		xch		a,@r0
		mov		61h,a			;save Z number again to 61h RAm address
		ret	
		
;================================================================================
;this routine check parity for XX data after user has input the number
check_parityZZ:
		mov		r2,#8
		mov		43h,#00h		 ;the RAM address to calculate parity even@odd
check_parityZZ2:
		rrc		a
		jc		increment_1_ZZ
incrZZ:
		djnz	r2,check_parityZZ2
		mov		r0,#43h
		cjne	@r0,#00h,ZZtwo
		clr		24h				;as bit address,put '0' at parity bit place
		ret
ZZtwo:	
		cjne	@r0,#02h,ZZfour
		clr		24h
		ret		
ZZfour:
		cjne	@r0,#04h,ZZsix
		clr		24h		
		ret
ZZsix:	
		cjne	@r0,#06h,ZZeight
		clr		24h		
		ret
ZZeight:
		cjne	@r0,#08h,ZZout
		clr		24h		 
		ret
ZZout:	
		setb	24h		;if not even, put '1' in parity bit place
		ret
				
increment_1_ZZ:
		inc		43h
		jmp		incrZZ		
		;ret
;=========================================================================			
		